%============United Multi-Operator Evolutionary Algorithms==========

%==========================REFERENCE================================
%% S. Elsayed, R. Sarker, D. Essam and N. Hamza (2014).
% Testing United Multi-Operator Evolutionary Algorithms on The CEC2014 Real-Parameter Numerical Optimization.
%IEEE Congress on Evolutionary Computation, Beijing, China
%==========================================================================

%%==========================================================================
% Should you have any queries, please contact
% Dr. Saber Elsayed. University of New South Wales at Canberra
% s.elsayed@adfa.edu.au
% https://sites.google.com/site/saberelsayed3/home
%==========================================================================


function [EA_1,EA_2,EA_3,EA_obj1,EA_obj2,EA_obj3] = ...
    inf_sharing(EA_1,EA_2,EA_3,EA_obj1,EA_obj2,EA_obj3, indx,bestx,bestold,f_optimal,mubest,add_pop, ParamsFunc)

global xmin xmax n  n1 n2 n3 current_eval I_fno

%% copy the best individual to each EAs
if EA_obj1(1)~=bestold+f_optimal
    EA_1(n1,:)=bestx(1,:);
    EA_obj1(n1)=bestold+f_optimal;
end
if EA_obj2(1)~=bestold+f_optimal
    EA_2(n2,:)=bestx(1,:);
    EA_obj2(n2)=bestold+f_optimal;
end
if EA_obj3(1)~=bestold+f_optimal
    EA_3(n3,:)=bestx(1,:);
    EA_obj3(n3)=bestold+f_optimal;
end
%% passing information among MOEAs
if indx==1
    xmean2=mean(EA_1(1:mubest,:));
    sigma2= (std(EA_1(1:mubest,:)));
    
    for i=n2-add_pop:n2-1
        EA_2(i,:)= normrnd(xmean2,sigma2);
        [EA_2, n, xmax, xmin] = han_boun (EA_2, n, xmax, xmin, I_fno,i);
        % EA_obj2(i) = cec14_func(EA_2(i,:)',I_fno);
        if current_eval < ParamsFunc.FunctionEvaluations
            EA_obj2(i) = feval(ParamsFunc.FevalName,ParamsFunc.FuncId, EA_2(i,:));
        else
        EA_1 = []; EA_2 = []; EA_3 = [];
        EA_obj1 = 0; EA_obj2 = 0; EA_obj3 = 0;
        return;
        end
        current_eval=current_eval+1;
    end
    for i=n3-add_pop:n3-1
        EA_3(i,:)= normrnd(xmean2,sigma2);
        [EA_3, n, xmax, xmin] = han_boun (EA_3, n, xmax, xmin, I_fno,i);
        % EA_obj3(i) = cec14_func(EA_3(i,:)',I_fno);
        if current_eval < ParamsFunc.FunctionEvaluations
            EA_obj3(i) = feval(ParamsFunc.FevalName,ParamsFunc.FuncId, EA_3(i,:));
        else
        EA_1 = []; EA_2 = []; EA_3 = [];
        EA_obj1 = 0; EA_obj2 = 0; EA_obj3 = 0;
        return;
        end
        current_eval=current_eval+1;
    end
elseif indx==2
    
    xmean2=mean(EA_2(1:mubest,:));
    sigma2= (std(EA_2(1:mubest,:)));
    for i=n1-add_pop:n1-1
        EA_1(i,:)= normrnd(xmean2,sigma2);
        [EA_1, n, xmax, xmin] = han_boun (EA_1, n, xmax, xmin, I_fno,i);
        % EA_obj1(i) = cec14_func(EA_1(i,:)',I_fno);
        if current_eval < ParamsFunc.FunctionEvaluations
            EA_obj1(i) = feval(ParamsFunc.FevalName,ParamsFunc.FuncId, EA_1(i,:));
        else
        EA_1 = []; EA_2 = []; EA_3 = [];
        EA_obj1 = 0; EA_obj2 = 0; EA_obj3 = 0;
        return;
        end
        current_eval=current_eval+1;
    end
    
    for i=n3-add_pop:n3-1
        EA_3(i,:)= normrnd(xmean2,sigma2);
        [EA_3, n, xmax, xmin] = han_boun (EA_3, n, xmax, xmin, I_fno,i);
        % EA_obj3(i) = cec14_func(EA_3(i,:)',I_fno);
        if current_eval < ParamsFunc.FunctionEvaluations
            EA_obj3(i) = feval(ParamsFunc.FevalName,ParamsFunc.FuncId, EA_3(i,:));
        else
        EA_1 = []; EA_2 = []; EA_3 = [];
        EA_obj1 = 0; EA_obj2 = 0; EA_obj3 = 0;
        return;
        end
        current_eval=current_eval+1;
    end
    
elseif indx==3
    
    xmean2=mean(EA_3(1:mubest,:));
    sigma2= (std(EA_3(1:mubest,:)));
    for i=n1-add_pop:n1-1
        EA_1(i,:)= normrnd(xmean2,sigma2);
        [EA_1, n, xmax, xmin] = han_boun (EA_1, n, xmax, xmin, I_fno,i);
        % EA_obj1(i) = cec14_func(EA_1(i,:)',I_fno);
        if current_eval < ParamsFunc.FunctionEvaluations
            EA_obj1(i) = feval(ParamsFunc.FevalName,ParamsFunc.FuncId, EA_1(i,:));
        else
        EA_1 = []; EA_2 = []; EA_3 = [];
        EA_obj1 = 0; EA_obj2 = 0; EA_obj3 = 0;
        return;
        end
        current_eval=current_eval+1;
    end
    
    for i=n2-add_pop:n2-1
        EA_2(i,:)= normrnd(xmean2,sigma2);
        [EA_2, n, xmax, xmin] = han_boun (EA_2, n, xmax, xmin, I_fno,i);
        % EA_obj2(i) = cec14_func(EA_2(i,:)',I_fno);
        if current_eval < ParamsFunc.FunctionEvaluations
            EA_obj2(i) = feval(ParamsFunc.FevalName,ParamsFunc.FuncId, EA_2(i,:));
        else
        EA_1 = []; EA_2 = []; EA_3 = [];
        EA_obj1 = 0; EA_obj2 = 0; EA_obj3 = 0;
        return;
        end
        current_eval=current_eval+1;
    end
end
end